# AnyKernel2 Ramdisk Mod Script
# osm0sis @ xda-developers

## AnyKernel setup
# begin properties
properties() {
kernel.string=PRIME-Kernel
do.devicecheck=1
do.modules=0
do.cleanup=1
do.cleanuponabort=0
device.name1=G930
device.name2=G935
device.name3=
device.name4=
device.name5=
} # end properties

file_getprop() { grep "^$2" "$1" | cut -d= -f2; }

# shell variables
block=$(ls /dev/block/platform/*/by-name/BOOT)
is_slot_device=0
is_any_port_rom=0
is_touchwiz=0
need_gpu_patch=0

test -f /system/framework/SmpsManager.jar && is_any_port_rom=1
test -f /system/framework/iqclient.jar && is_n8_port_rom=1
test -f /system/framework/samsung-framework.jar && is_touchwiz=1

is_pure_edition=$(cat kernel.string|grep -c "Pure")

## AnyKernel methods (DO NOT CHANGE)
# import patching functions/variables - see for reference
. /tmp/anykernel/tools/ak2-core.sh


## AnyKernel file attributes
# set permissions/ownership for included ramdisk files
chmod -R 750 $ramdisk/*;
chmod -R root:root $ramdisk/*;

## AnyKernel install
ui_print "    dump boot-image..."
dump_boot

# begin ramdisk changes
# clear ------------------------------------------------------------------------
ui_print "    useless files removal"
remove_list1="init.services.rc init.PRIME-Kernel.rc init.spectrum.sh init.spectrum.rc init.primal.rc init.noto.rc kernelinit.sh wakelock.sh super.sh cortexbrain-tune.sh spectrum.sh"
remove_list2="init.spectrum.sh kernelinit.sh wakelock.sh super.sh cortexbrain-tune.sh spectrum.sh spa init_d.sh moro-init.sh"
for i in $remove_list; do
	if test -f $i; then
		rm $i
		rm sbin/$i
		sed -i "/$i/d" init.rc 
		sed -i "/$i/d" init.samsungexynos8890.rc 
	fi
	if test -f sbin/$i; then
		rm sbin/$i
		sed -i "/sbin\/$i/d" init.rc 
		sed -i "/sbin\/$i/d" init.samsungexynos8890.rc 
	fi
done
for i in $(ls ./res); do
	test $i != "images" && rm -R ./res/$i
done
rm /system/bin/uci
rm /system/xbin/uci

cp -r /tmp/anykernel/rdtmp/res/* ./res
chmod 755 $ramdisk/res/*
chmod 755 $ramdisk/res/bin/*

# busybox install
#cp $bin/busybox $ramdisk/res/bin/


# default.prop -----------------------------------------------------------------
ui_print "    patching ramdisk"
#patch_prop default.prop persist.sys.usb.config "mtp,adb"
#patch_prop default.prop "ro.secure" "0"
#patch_prop default.prop "ro.debuggable" "1"
#insert_line default.prop "persist.service.adb.enable=" after "persist.sys.usb.config=" "persist.service.adb.enable=1"
if [ $is_touchwiz -eq 1 ]; then
	insert_line default.prop "# PRIME-KERNEL_PROPERTIES" after "debug.atrace.tags.enableflags=" ""
	insert_line default.prop "# PRIME-KERNEL_PROPERTIES" before "# BOOTIMAGE_BUILD_PROPERTIES" "# PRIME-KERNEL_PROPERTIES\n#\nsys.prime-kernel.installed=1\n\n#"
	insert_line default.prop "telephony.lteOnCdmaDevice=0" before "persist.security.ams.enforcing=" "telephony.lteOnCdmaDevice=0"
	insert_line default.prop "ro.securestorage.support=false" after "sys.prime-kernel.installed=" "ro.securestorage.support=false"
	insert_line default.prop "ro.securestorage.knox=false" after "ro.securestorage.support=" "ro.securestorage.knox=false"
	insert_line default.prop "ro.config.tima=0" after "ro.securestorage.support=" "ro.config.tima=0"
	insert_line default.prop "ro.config.rkp=false" after "ro.config.tima=0" "ro.config.rkp=false"
	insert_line default.prop "ro.config.kap=false" after "ro.config.rkp=false" "ro.config.kap=false"
	insert_line default.prop "wlan.wfd.hdcp=disable" after "ro.config.kap=" "wlan.wfd.hdcp=disable"
	insert_line default.prop "ro.config.dmverity=false" after "wlan.wfd.hdcp=" "ro.config.dmverity=false"
	patch_prop default.prop telephony.lteOnCdmaDevice 0
	patch_prop default.prop ro.securestorage.support false
	patch_prop default.prop ro.config.tima 0
	patch_prop default.prop ro.config.rkp false
	patch_prop default.prop ro.config.kap false
	patch_prop default.prop wlan.wfd.hdcp disable
	patch_prop default.prop ro.config.dmverity false
else
	insert_line default.prop "ro.sys.sdcardfs=false" after "debug.atrace.tags.enableflags=0" "ro.sys.sdcardfs=false";
fi

# init.environ.rc --------------------------------------------------------------
#if [ $is_any_port_rom -eq 1 ]; then
#	replace_line init.environ.rc "export LD_PRELOAD" "    export LD_PRELOAD libTcpOptimizer.so"
#fi

# init.rc
sed -i "/init.prime-kernel.rc/d" init.rc
sed -i "/init.prime-kernel.rc/d" init.samsungexynos8890.rc
line=$((`grep -n "import" "init.rc" | tail -n1 | cut -d: -f1` + 1));
sed -i "${line}s;^;import /init.prime-kernel.rc\n;" init.rc

remove_section init.rc "# . SEC_SELINUX_PORTING_COMMON" "# . SEC_SELINUX_PORTING_COMMON"
remove_section init.rc "## WTL_EDM_START" "## WTL_EDM_END"
remove_section init.rc "service auditd /system/bin/auditd -k" "    oneshot"
remove_section init.rc "service auditd /system/bin/auditd -k" "oneshot"
replace_line init.rc "setprop selinux.reload_policy 1" "#setprop selinux.reload_policy 1"
replace_line init.rc "setprop selinux.reload_policy 1" "#setprop selinux.reload_policy 1"
sed -i "/start auditd/d" init.rc


# init.samsungexynos8890.rc ----------------------------------------------------
insert_line init.samsungexynos8890.rc "service visiond /system/bin/visiond" before "# SSWAP" "\n# AIR\nservice visiond /system/bin/visiond\n    class main\n    user system\n    group system camera media media_rw\n"
insert_line init.samsungexynos8890.rc "mount f2fs /dev/block/platform/155a0000.ufs/by-name/SYSTEM /system wait ro" after "mount ext4 /dev/block/platform/155a0000.ufs/by-name/SYSTEM /system wait ro" "    mount f2fs /dev/block/platform/155a0000.ufs/by-name/SYSTEM /system wait ro"


# replace

if [ $is_pure_edition -eq 1 ]; then
  ui_print "    is pure edition"
  replace_file fstab.samsungexynos8890 644 TouchWiz/fstab.pure
  #rm -Rf $ramdisk/res/bin
  rm -Rf $ramdisk/res/synapse
  rm -Rf $ramdisk/res/stuff
  rm -Rf $ramdisk/res/apk
  rm -Rf $ramdisk/sbin/uci
  #rm -Rf $ramdisk/sbin/resetprop
fi

if [ $is_touchwiz -eq 1 ]; then
	#replace_file sbin/adbd 755 TouchWiz/sbin/adbd
	replace_file init.environ.rc 755 TouchWiz/init.environ.rc
	if [ $is_any_port_rom -eq 1 ]; then
		replace_line init.environ.rc "export LD_PRELOAD" "    export LD_PRELOAD libTcpOptimizer.so"
	fi
	if [ $is_pure_edition -eq 0 ]; then
		replace_file fstab.samsungexynos8890 644 TouchWiz/fstab.samsungexynos8890
	fi
else
	replace_file fstab.samsungexynos8890 644 aosp/fstab.samsungexynos8890
fi
if [ $is_pure_edition -eq 1 ]; then
	replace_file init.prime-kernel.rc 644 init.prime-kernel.rc.pure
fi

if [ $is_n8_port_rom -eq 1 ]; then
	replace_file init 750 TW_Note8/init
	chmod 750 $ramdisk/init
fi

# for Magisk
if [ -d .backup ]; then
	#cp -f init.rc .backup/
	#cp -f fstab.samsungexynos8890 .backup/
	#sed -i "/init.magisk.rc/d" .backup/init.rc
	rm -Rf .backup
fi

# modify init for F2FS mount
ui_print "    patching init binary"
#cat init|sed "s/\x65\x32\x66\x73\x63\x6B\x00\x2D\x79/\x65\x32\x66\x73\x63\x6B\x00\x2D\x6E/g" > init_temp
$bin/sukernel --hexpatch $patch/TouchWiz/init.hexpatch $ramdisk/init $ramdisk/init

# selinux_contexts
chcon -R 'u:object_r:system_file:s0' $ramdisk/res/
chcon -R 'u:object_r:rootfs:s0' $ramdisk/sbin/
chcon 'u:object_r:init_exec:s0' $ramdisk/init
chcon 'u:object_r:system_file:s0' $ramdisk/sbin/uci

# end ramdisk changes

ui_print "    write boot-image..."
write_boot

## end install
